#take pi_0=1 , the conservative version          
#p: pvalues
#p.omt: pvalues from permutation
#cutoff: \gamma
#independence
pFDR1 <- function(p,cutoff,alpha=.1,B=100)
  { if(cutoff>0) {
    m <- length(p)
    FDR <- min(cutoff/(max(sum(p<=cutoff),1)/m),1)
    pFDR <- min(FDR/(1-(1-cutoff)^m),1)
    
    FDR1<-pFDR1<-rep(NA,B)
    for ( b in 1:B)
    { p1<-sample(p,replace=T)
      FDR1[b]<-min(cutoff/(max(sum(p1<=cutoff),1)/m),1)
      pFDR1[b] <- min(FDR1[b]/(1-(1-cutoff)^m),1)
     }
    
    value <- c(FDR,pFDR,quantile(FDR1,1-alpha),quantile(pFDR1,1-alpha),quantile(FDR1,alpha),quantile(pFDR1,alpha),1-alpha)}
        else value <- rep(NA,7)
    names(value) <- c("FDR","pFDR","FDR upper","pFDR upper","FDP lower","pFDP lower","quantile level")
    value
                                        #    return(FDR,pFDR,FDR.9=quantile(FDR1,1-alpha),pFDR.9=quantile(pFDR1,1-alpha))
}


## to get q-value
Qvalue <- function(pFDR)
  { pFDR <- c(pFDR,recursive=T)
    c(min(pFDR),sapply(1:(length(pFDR)-1),function(k) min(pFDR[-(1:k)])))}
