change <- epsilon+1
log.lik.prev <- Inf
likelihoods <- matrix(0,n,N)
while(change > epsilon){
 
  for(i in 1:N){
    Vi <- solve(Sigma[,,i])
    detV <-  sum(log(eigen(Sigma[,,i])$values))
    likelihoods[,i] <- exp(-0.5*apply(sweep(x,2,mu[,i]),1,function(x) detV + x%*%Vi%*%x))
  }
  
  ##E - STEP
  z <- sweep(likelihoods,2,Pi,FUN="*")##likelihoods for each class
  lik <- apply(z,1,sum) ##total likelihood for each point
  z <- z/lik ## this is the zij's
  z[lik==0] <- 0
  log.lik <- sum(log(lik)) ##this is the log likelihood, used for stopping
  change <- abs(log.lik-log.lik.prev)
  log.lik.prev <- log.lik
  Pi <- apply(z,2,mean)
  
  ##M - STEP
  ##first means
  for(i in 1:N)
    mu[,i] <- apply(sweep(x,1,z[,i],"*"),2,mean)/Pi[i]
  for(i in 1:N){
    aux <- array(apply(sweep(x,2,mu[,i]),1,function(x) x%o%x),dim=c(m,m,n))
    Sigma[,,i] <- apply(sweep(aux,3,z[,i],"*"),c(1,2),mean)/Pi[i]
  }
  
 ## print(log.lik)
 ## print(signif(Pi,2))
 ## print(signif(mu,4))
  ##print(signif(Sigma,2))
  if(PLOT){
    par(mfrow=c(m/2,2))
    for(i in 1:(m/2)){
      hist(x[,i],nc=50,prob=T,main=paste("red",as.character(i)),col=2)
      xx <- seq(min(x),max(x),len=200)
      dd <- rep(0,length(xx))
      for(j in 1:N){
        abline(v=mu[i,j],col=j+1)
        dd <- dd + Pi[j]*dnorm(xx,mu[i,j],sqrt(Sigma[i,i,j]))
      }
      lines(xx,dd,col=4)
      hist(x[,i+m/2],nc=50,prob=T,main=paste("green",as.character(i)),col=3)
      dd <- rep(0,length(xx))
      for(j in 1:N){
        abline(v=mu[i+m/2,j],col=j+1)
        dd <- dd + Pi[j]*dnorm(xx,mu[i+m/2,j],sqrt(Sigma[i+m/2,i+m/2,j]))
      }
      lines(xx,dd,col=4)
    }
  }
}
