cat("computing likelihood\n")
likelihoods <- sapply(c(1,2,3),function(i){
  Vi <- solve(Sigma[,,i])
  detV <-  sum(log(eigen(Sigma[,,i])$values))
  Pi[i]*exp(-0.5*apply(sweep(x,2,mu[,i]),1,function(x) detV + x%*%Vi%*%x))
})

##now the z-test
cat("computing z-score\n")
modelvar <- sqrt(sapply(1:3,function(i) (1/(m/2)*c(rep(1,m/2),rep(-1,m/2)))%*%Sigma[,,i]%*%(1/(m/2)*c(rep(1,m/2),rep(-1,m/2)))))
z <- sapply((1:dim(x)[1]),function(i){
  aux <- sapply(1:3,function(j)
                mean((x[i,1:(m/2)]-x[i,(m/2+1):m])-
                    (mu[1:(m/2),j]-mu[(m/2+1):m,j]))/modelvar[j])
  sum(likelihoods[i,]*aux)/sum(likelihoods[i,]) 
})

##CALLS
cat("computing red calls.\n")
redcalls <- sapply(c(1,2,3),function(i){
  o <- 1:(m/2)
  xx <- as.matrix(x[,o])
  Vi <- solve(Sigma[o,o,i])
  detV <-  sum(log(eigen(Sigma[o,o,i])$values))
  Pi[i]*exp(-0.5*apply(sweep(xx,2,mu[o,i]),1,function(x) detV + x%*%Vi%*%x))
})
redcalls <- apply(redcalls,1,function(x) c("A","M","P")[order(-x)[1]])
cat("computing green calls.\n")
greencalls <- sapply(c(1,2,3),function(i){
  o <- (m/2+1):m
  xx <- as.matrix(x[,o])
  Vi <- solve(Sigma[o,o,i])
  detV <-  sum(log(eigen(Sigma[o,o,i])$values))
  Pi[i]*exp(-0.5*apply(sweep(xx,2,mu[o,i]),1,function(x) detV + x%*%Vi%*%x))
})
greencalls <- apply(greencalls,1,function(x) c("A","M","P")[order(-x)[1]])


