##nsample is the number of replicated arrays in each group (experimental or control)
##B is the number of simulations
nsample <-25;B=250
##################################################
source("sim.r")
muhat <- Sigmahat <- Pihat <-  rep(list(NULL),B)
top.z <- top.t <- top.r <- NULL
set.seed(41805)
for (k in 1:B)
  {
    x <- SIMsub(ngenes0,Pi0,Sigma0,mu1,mu0,S.PA,S.PM,S.MA)
#    cat("starting the em\n")
    N <- 3 #number of classes
    n <- dim(x)[[1]]
    m <- dim(x)[[2]]
    mu <- mu0
    Pi <- Pi0
    Sigma <- Sigma0
    PLOT=F;epsilon=.0001
    source("em.R")
#    print("done EM") 
    muhat[[k]] <- mu
    Sigmahat[[k]] <- Sigma
    Pihat[[k]] <- Pi


    source("getz.r")
    order.z <- order(-abs(z))
    top.z <-cbind(top.z,c(sum(order.z[1:9]<10)/9,sum(order.z[1:10]<10)/9,sum(order.z[1:15]<10)/9,sum(order.z[1:25]<10)/9))
    

      ##compute t-test
    diff <- x[,1:nsample] - x[,(nsample+1):m]
    s <- apply(diff,1,function(xx){ ##the standard error estimates
      sqrt(1 / (nsample*(nsample-1)) * sum( ( xx- mean(xx))^2 ) )})
    t <- apply(diff,1,mean)/s
    order.t <- order(-abs(t))
    top.t <- cbind(top.t,c(sum(order.t[1:9]<10)/9,sum(order.t[1:10]<10)/9,sum(order.t[1:15]<10)/9,sum(order.t[1:25]<10)/9))

    ##compute the ave-rank
    avgrank <- apply(apply(diff,2,rank),1,mean)/nrow(x)
    absavgrank <- apply(cbind(avgrank,1-avgrank),1,max)
    order.r<- order(-absavgrank)
    top.r <- cbind(top.r,c(sum(order.r[1:9]<10)/9,sum(order.r[1:10]<10)/9,sum(order.r[1:15]<10)/9,sum(order.r[1:25]<10)/9))
    
 }

##################################################
save(n,m,muhat,Sigmahat,Pihat,file="N25.rda")
save(top.z,top.t,top.r,file="top25.rda")

q()
n
